 /*
 * file      : src/win_new_year.c
 * project   : tm
 * with      : Gtk-2
 *
 * copyright : (C) 2012 by Claude BULIN
 *
 * TM - Edition des heures de travail / Edition of working hours
 * GNU General Public License
 * 
 * This file is part of TM.
 * 
 * TM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 * 
 * TM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with TM.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif

#ifdef ENABLE_NLS
	#include <libintl.h>
	#define _(String) gettext (String)
#endif

#include <gtk/gtk.h>
#include <stdlib.h>

#ifdef ENABLE_STATIC_LIBRARY
	#include "../lib_tm/lib.h"
#endif

#include "win_new_year.h"
#include "global.h"
#include "fileselect.h"
#include "edit_year.h"
#include "configuser.h"
#include "win_info.h"




typedef struct {

	GtkWidget	*AdrWin;		// Adresse de la fenetre
	gboolean	IsShow;			// TRUE or FALSE
	GtkWidget	*AdrNewYear;		// Adresse SpinButton
	void		(*Func_Extern)( gboolean BoolAccept );	// 
	gboolean	BoolAccept;
	
} VAR_WIN_NEW_YEAR;

VAR_WIN_NEW_YEAR VarWinNewYear = { 
	
	NULL,
	FALSE,
	NULL,
	NULL,
	FALSE
	
	};

// 
// 
gboolean on_window_new_year_delete_event( GtkWidget *widget, GdkEvent *event, gpointer user_data )
{
	VarWinNewYear.IsShow = FALSE;
	gtk_widget_hide( VarWinNewYear.AdrWin );
	return (TRUE);
}
// 
// 
gboolean on_window_new_year_destroy_event( GtkWidget *widget, GdkEvent *event, gpointer user_data )
{
	VarWinNewYear.IsShow = FALSE;
	gtk_widget_hide( VarWinNewYear.AdrWin );
	return (TRUE);
}
// 
// 
void on_spinbutton_window_new_year_value_changed( GtkSpinButton *spinbutton, gpointer user_data )
{
	if( NULL != VarWinNewYear.AdrNewYear ) {
		// VarWinNewYear.NewYear = (guint)gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarWinNewYear.AdrNewYear))
		// EditYear_set_new_year( (guint)gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarWinNewYear.AdrNewYear) ));
		// g_print( "NOUVELLE ANNEE = %d\n", VarWinNewYear.NewYear );
		
		Config.ChoiceNewYear = (gint)gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarWinNewYear.AdrNewYear));
	}
}
// AFFICGE L'ANNEE PAR DEFAUT
// 
void on_spinbutton_window_new_year_realize( GtkWidget *widget, gpointer user_data )
{
	// gtk_spin_button_set_value( GTK_SPIN_BUTTON(widget), EditYear_get_new_year() );
	gtk_spin_button_set_value( GTK_SPIN_BUTTON(widget),Config.ChoiceNewYear );
	VarWinNewYear.AdrNewYear = widget;
}
// 
// 
void on_button_ok_window_new_year_clicked( GtkButton *button, gpointer user_data )
{
	VarWinNewYear.IsShow = FALSE;
	EditYear_set_new_year( (guint)gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarWinNewYear.AdrNewYear) ));
	if( VarWinNewYear.Func_Extern ) (*VarWinNewYear.Func_Extern)( VarWinNewYear.BoolAccept );
	gtk_widget_hide( VarWinNewYear.AdrWin );
}
// 
// 
void on_button_cancel_window_new_year_clicked( GtkButton *button, gpointer user_data )
{
	VarWinNewYear.IsShow = FALSE;
	gtk_widget_hide( VarWinNewYear.AdrWin );
}
void on_button_pathname_new_year_realize( GtkWidget *widget, gpointer user_data )
{
	// SI LE NOM DE FICHIER EST ABSENT
	if( TRUE == libutils_test_dir_exist( Config.PathNameFileNEWBase )) {
		gchar *path = g_strdup( Config.PathNameFileNEWBase );
		g_free( Config.PathNameFileNEWBase );
		Config.PathNameFileNEWBase = NULL;
		Config.PathNameFileNEWBase = g_strdup_printf( "%s/BASE", path );
		g_free( path );
		path = NULL;
	}
	gtk_label_set_label( GTK_LABEL(GLADE_GET_OBJECT("label_pathname_new_year")), Config.PathNameFileNEWBase );
}
// 
// 
void WinNewYear_select( gchar *p_path )
{	
	// SI PATH + FILE = OK
	if( NULL != p_path ) {
		if( FALSE == libutils_test_write( p_path )) {
			wininfo_create( VarWinNewYear.AdrWin,
				_("Erreur choix lieu de stockage !"),
				_("   Le lieu de stockage temporaire doit pouvoir     "),
				  "\n",
				_("   etre accessible en ecriture."),
				  "\n\n",
				_("   Veuillez recommencer."),
				  "\n",
				  "");
			return;
		}
		// STOCKAGE DU NOUVEAU PATH_NAME_FILE
		if( NULL != Config.PathNameFileNEWBase ) {
			g_free( Config.PathNameFileNEWBase ); 
			Config.PathNameFileNEWBase = NULL;
		}
		Config.PathNameFileNEWBase = g_strdup( p_path );
		// ECRITURE DU NOUVEAU PATH_NAME_FILE DANS LE BOUTON D'APPEL A FILESELECT
		gtk_label_set_label( GTK_LABEL(GLADE_GET_OBJECT("label_pathname_new_year")), p_path );
		VarWinNewYear.BoolAccept  = TRUE;
	}
}
void on_button_pathname_new_year_clicked( GtkButton *button, gpointer user_data )
{
	fileselect( _("Choix d'un nom de fichier pour la base"), GTK_FILE_CHOOSER_ACTION_SAVE,  WinNewYear_select, Config.PathNameFileNEWBase, VarWinNewYear.AdrWin );
}
// 
// 
void WinNewYear_open( void (*Func_Extern)(gboolean BoolAccept) )
{
	VarWinNewYear.Func_Extern = Func_Extern;
	VarWinNewYear.BoolAccept  = FALSE;
	
	if( TRUE == VarWinNewYear.IsShow ) {
		gdk_window_raise( VarWinNewYear.AdrWin->window );
	}
	else {
		if( NULL == VarWinNewYear.AdrWin ) {
			VarWinNewYear.AdrWin = GTK_WIDGET(GLADE_GET_OBJECT("window_new_year"));
			gtk_builder_connect_signals( GtkBuilderProjet, NULL );
		}
		gtk_window_set_transient_for( GTK_WINDOW(VarWinNewYear.AdrWin), GTK_WINDOW(WindMain) );
		gtk_window_set_modal( GTK_WINDOW(VarWinNewYear.AdrWin), TRUE );
		libutils_set_default_icone_to_win( VarWinNewYear.AdrWin );
		gtk_window_set_title( GTK_WINDOW( VarWinNewYear.AdrWin ), "Time Management" );
		gtk_window_set_position( GTK_WINDOW(VarWinNewYear.AdrWin), GTK_WIN_POS_CENTER );
		VarWinNewYear.IsShow = TRUE;
		gtk_widget_show( VarWinNewYear.AdrWin );
	}
}














